import{S as Ft,i as Vt,s as Jt,e as l,k as c,w as q,t as p,M as Kt,c as n,d as t,m,a as o,x as S,h as i,b as h,T as Qt,G as e,g as r,y as L,L as Wt,q as C,o as T,B as G,v as Yt}from"../chunks/vendor-hf-doc-builder.js";import{I as _t,C as cs}from"../chunks/CodeBlock-hf-doc-builder.js";function Zt(bt){let g,ms,_,j,K,A,Ds,Q,Os,fs,b,I,yt,us,f,W,xs,Ns,Y,Xs,Rs,D,Ms,zs,B,Hs,Bs,Z,Fs,Vs,ds,F,Js,gs,O,_s,V,Ks,bs,x,ys,J,Qs,ws,N,js,y,v,ss,X,Ws,ts,Ys,vs,R,$s,$,Zs,M,st,tt,ks,k,es,et,at,as,lt,Ps,w,P,ls,z,nt,ns,ot,Es,H,Us,E,rt,os,pt,it,qs,u,rs,ht,ct,ps,mt,ft,is,ut,dt,hs,gt,Ss;return A=new _t({}),O=new cs({props:{code:"pip install safetensors huggingface_hub torch",highlighted:"pip install safetensors huggingface_hub torch"}}),x=new cs({props:{code:`import os
import datetime
from huggingface_hub import hf_hub_download
from safetensors.torch import load_file
import torch`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> os
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> datetime
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> hf_hub_download
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> safetensors.torch <span class="hljs-keyword">import</span> load_file
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch`}}),N=new cs({props:{code:`sf_filename = hf_hub_download("gpt2", filename="model.safetensors")
pt_filename = hf_hub_download("gpt2", filename="pytorch_model.bin")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>sf_filename = hf_hub_download(<span class="hljs-string">&quot;gpt2&quot;</span>, filename=<span class="hljs-string">&quot;model.safetensors&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pt_filename = hf_hub_download(<span class="hljs-string">&quot;gpt2&quot;</span>, filename=<span class="hljs-string">&quot;pytorch_model.bin&quot;</span>)`}}),X=new _t({}),R=new cs({props:{code:`start_st = datetime.datetime.now()
weights = load_file(sf_filename, device="cpu")
load_time_st = datetime.datetime.now() - start_st
print(f"Loaded safetensors {load_time_st}")

start_pt = datetime.datetime.now()
weights = torch.load(pt_filename, map_location="cpu")
load_time_pt = datetime.datetime.now() - start_pt
print(f"Loaded pytorch {load_time_pt}")

print(f"on CPU, safetensors is faster than pytorch by: {load_time_pt/load_time_st:.1f} X")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>start_st = datetime.datetime.now()
<span class="hljs-meta">&gt;&gt;&gt; </span>weights = load_file(sf_filename, device=<span class="hljs-string">&quot;cpu&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>load_time_st = datetime.datetime.now() - start_st
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Loaded safetensors <span class="hljs-subst">{load_time_st}</span>&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>start_pt = datetime.datetime.now()
<span class="hljs-meta">&gt;&gt;&gt; </span>weights = torch.load(pt_filename, map_location=<span class="hljs-string">&quot;cpu&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>load_time_pt = datetime.datetime.now() - start_pt
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Loaded pytorch <span class="hljs-subst">{load_time_pt}</span>&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;on CPU, safetensors is faster than pytorch by: <span class="hljs-subst">{load_time_pt/load_time_st:<span class="hljs-number">.1</span>f}</span> X&quot;</span>)
Loaded safetensors <span class="hljs-number">0</span>:<span class="hljs-number">00</span>:<span class="hljs-number">00.004015</span>
Loaded pytorch <span class="hljs-number">0</span>:<span class="hljs-number">00</span>:<span class="hljs-number">00.307460</span>
on CPU, safetensors <span class="hljs-keyword">is</span> faster than pytorch by: <span class="hljs-number">76.6</span> X`}}),z=new _t({}),H=new cs({props:{code:`# This is required because this feature hasn't been fully verified yet, but 
# it's been tested on many different environments
os.environ["SAFETENSORS_FAST_GPU"] = "1"

# CUDA startup out of the measurement
torch.zeros((2, 2)).cuda()

start_st = datetime.datetime.now()
weights = load_file(sf_filename, device="cuda:0")
load_time_st = datetime.datetime.now() - start_st
print(f"Loaded safetensors {load_time_st}")

start_pt = datetime.datetime.now()
weights = torch.load(pt_filename, map_location="cuda:0")
load_time_pt = datetime.datetime.now() - start_pt
print(f"Loaded pytorch {load_time_pt}")

print(f"on GPU, safetensors is faster than pytorch by: {load_time_pt/load_time_st:.1f} X")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># This is required because this feature hasn&#x27;t been fully verified yet, but </span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># it&#x27;s been tested on many different environments</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>os.environ[<span class="hljs-string">&quot;SAFETENSORS_FAST_GPU&quot;</span>] = <span class="hljs-string">&quot;1&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># CUDA startup out of the measurement</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>torch.zeros((<span class="hljs-number">2</span>, <span class="hljs-number">2</span>)).cuda()

<span class="hljs-meta">&gt;&gt;&gt; </span>start_st = datetime.datetime.now()
<span class="hljs-meta">&gt;&gt;&gt; </span>weights = load_file(sf_filename, device=<span class="hljs-string">&quot;cuda:0&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>load_time_st = datetime.datetime.now() - start_st
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Loaded safetensors <span class="hljs-subst">{load_time_st}</span>&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>start_pt = datetime.datetime.now()
<span class="hljs-meta">&gt;&gt;&gt; </span>weights = torch.load(pt_filename, map_location=<span class="hljs-string">&quot;cuda:0&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>load_time_pt = datetime.datetime.now() - start_pt
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Loaded pytorch <span class="hljs-subst">{load_time_pt}</span>&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;on GPU, safetensors is faster than pytorch by: <span class="hljs-subst">{load_time_pt/load_time_st:<span class="hljs-number">.1</span>f}</span> X&quot;</span>)
Loaded safetensors <span class="hljs-number">0</span>:<span class="hljs-number">00</span>:<span class="hljs-number">00.165206</span>
Loaded pytorch <span class="hljs-number">0</span>:<span class="hljs-number">00</span>:<span class="hljs-number">00.353889</span>
on GPU, safetensors <span class="hljs-keyword">is</span> faster than pytorch by: <span class="hljs-number">2.1</span> X`}}),{c(){g=l("meta"),ms=c(),_=l("h1"),j=l("a"),K=l("span"),q(A.$$.fragment),Ds=c(),Q=l("span"),Os=p("Speed Comparison"),fs=c(),b=l("a"),I=l("img"),us=c(),f=l("p"),W=l("code"),xs=p("Safetensors"),Ns=p(" is really fast. Let\u2019s compare it against "),Y=l("code"),Xs=p("PyTorch"),Rs=p(" by loading "),D=l("a"),Ms=p("gpt2"),zs=p(" weights. To run the "),B=l("a"),Hs=p("GPU benchmark"),Bs=p(", make sure your machine has GPU or you have selected "),Z=l("code"),Fs=p("GPU runtime"),Vs=p(" if you are using Google Colab."),ds=c(),F=l("p"),Js=p("Before you begin, make sure you have all the necessary libraries installed:"),gs=c(),q(O.$$.fragment),_s=c(),V=l("p"),Ks=p("Let\u2019s start by importing all the packages that will be used:"),bs=c(),q(x.$$.fragment),ys=c(),J=l("p"),Qs=p("Download safetensors & torch weights for gpt2:"),ws=c(),q(N.$$.fragment),js=c(),y=l("h3"),v=l("a"),ss=l("span"),q(X.$$.fragment),Ws=c(),ts=l("span"),Ys=p("CPU benchmark"),vs=c(),q(R.$$.fragment),$s=c(),$=l("p"),Zs=p("This speedup is due to the fact that this library avoids unnecessary copies by mapping the file directly. It is actually possible to do on "),M=l("a"),st=p("pure pytorch"),tt=p(`.
The currently shown speedup was gotten on:`),ks=c(),k=l("ul"),es=l("li"),et=p("OS: Ubuntu 18.04.6 LTS"),at=c(),as=l("li"),lt=p("CPU: Intel(R) Xeon(R) CPU @ 2.00GHz"),Ps=c(),w=l("h3"),P=l("a"),ls=l("span"),q(z.$$.fragment),nt=c(),ns=l("span"),ot=p("GPU benchmark"),Es=c(),q(H.$$.fragment),Us=c(),E=l("p"),rt=p("The speedup works because this library is able to skip unecessary CPU allocations. It is unfortunately not replicable in pure pytorch as far as we know. The library works by memory mapping the file, creating the tensor empty with pytorch and calling "),os=l("code"),pt=p("cudaMemcpy"),it=p(` directly to move the tensor directly on the GPU.
The currently shown speedup was gotten on:`),qs=c(),u=l("ul"),rs=l("li"),ht=p("OS: Ubuntu 18.04.6 LTS."),ct=c(),ps=l("li"),mt=p("GPU: Tesla T4"),ft=c(),is=l("li"),ut=p("Driver Version: 460.32.03"),dt=c(),hs=l("li"),gt=p("CUDA Version: 11.2"),this.h()},l(s){const a=Kt('[data-svelte="svelte-1phssyn"]',document.head);g=n(a,"META",{name:!0,content:!0}),a.forEach(t),ms=m(s),_=n(s,"H1",{class:!0});var Ls=o(_);j=n(Ls,"A",{id:!0,class:!0,href:!0});var wt=o(j);K=n(wt,"SPAN",{});var jt=o(K);S(A.$$.fragment,jt),jt.forEach(t),wt.forEach(t),Ds=m(Ls),Q=n(Ls,"SPAN",{});var vt=o(Q);Os=i(vt,"Speed Comparison"),vt.forEach(t),Ls.forEach(t),fs=m(s),b=n(s,"A",{href:!0,target:!0,class:!0});var $t=o(b);I=n($t,"IMG",{alt:!0,class:!0,src:!0}),$t.forEach(t),us=m(s),f=n(s,"P",{});var d=o(f);W=n(d,"CODE",{});var kt=o(W);xs=i(kt,"Safetensors"),kt.forEach(t),Ns=i(d," is really fast. Let\u2019s compare it against "),Y=n(d,"CODE",{});var Pt=o(Y);Xs=i(Pt,"PyTorch"),Pt.forEach(t),Rs=i(d," by loading "),D=n(d,"A",{href:!0,rel:!0});var Et=o(D);Ms=i(Et,"gpt2"),Et.forEach(t),zs=i(d," weights. To run the "),B=n(d,"A",{href:!0});var Ut=o(B);Hs=i(Ut,"GPU benchmark"),Ut.forEach(t),Bs=i(d,", make sure your machine has GPU or you have selected "),Z=n(d,"CODE",{});var qt=o(Z);Fs=i(qt,"GPU runtime"),qt.forEach(t),Vs=i(d," if you are using Google Colab."),d.forEach(t),ds=m(s),F=n(s,"P",{});var St=o(F);Js=i(St,"Before you begin, make sure you have all the necessary libraries installed:"),St.forEach(t),gs=m(s),S(O.$$.fragment,s),_s=m(s),V=n(s,"P",{});var Lt=o(V);Ks=i(Lt,"Let\u2019s start by importing all the packages that will be used:"),Lt.forEach(t),bs=m(s),S(x.$$.fragment,s),ys=m(s),J=n(s,"P",{});var Ct=o(J);Qs=i(Ct,"Download safetensors & torch weights for gpt2:"),Ct.forEach(t),ws=m(s),S(N.$$.fragment,s),js=m(s),y=n(s,"H3",{class:!0});var Cs=o(y);v=n(Cs,"A",{id:!0,class:!0,href:!0});var Tt=o(v);ss=n(Tt,"SPAN",{});var Gt=o(ss);S(X.$$.fragment,Gt),Gt.forEach(t),Tt.forEach(t),Ws=m(Cs),ts=n(Cs,"SPAN",{});var At=o(ts);Ys=i(At,"CPU benchmark"),At.forEach(t),Cs.forEach(t),vs=m(s),S(R.$$.fragment,s),$s=m(s),$=n(s,"P",{});var Ts=o($);Zs=i(Ts,"This speedup is due to the fact that this library avoids unnecessary copies by mapping the file directly. It is actually possible to do on "),M=n(Ts,"A",{href:!0,rel:!0});var It=o(M);st=i(It,"pure pytorch"),It.forEach(t),tt=i(Ts,`.
The currently shown speedup was gotten on:`),Ts.forEach(t),ks=m(s),k=n(s,"UL",{});var Gs=o(k);es=n(Gs,"LI",{});var Dt=o(es);et=i(Dt,"OS: Ubuntu 18.04.6 LTS"),Dt.forEach(t),at=m(Gs),as=n(Gs,"LI",{});var Ot=o(as);lt=i(Ot,"CPU: Intel(R) Xeon(R) CPU @ 2.00GHz"),Ot.forEach(t),Gs.forEach(t),Ps=m(s),w=n(s,"H3",{class:!0});var As=o(w);P=n(As,"A",{id:!0,class:!0,href:!0});var xt=o(P);ls=n(xt,"SPAN",{});var Nt=o(ls);S(z.$$.fragment,Nt),Nt.forEach(t),xt.forEach(t),nt=m(As),ns=n(As,"SPAN",{});var Xt=o(ns);ot=i(Xt,"GPU benchmark"),Xt.forEach(t),As.forEach(t),Es=m(s),S(H.$$.fragment,s),Us=m(s),E=n(s,"P",{});var Is=o(E);rt=i(Is,"The speedup works because this library is able to skip unecessary CPU allocations. It is unfortunately not replicable in pure pytorch as far as we know. The library works by memory mapping the file, creating the tensor empty with pytorch and calling "),os=n(Is,"CODE",{});var Rt=o(os);pt=i(Rt,"cudaMemcpy"),Rt.forEach(t),it=i(Is,` directly to move the tensor directly on the GPU.
The currently shown speedup was gotten on:`),Is.forEach(t),qs=m(s),u=n(s,"UL",{});var U=o(u);rs=n(U,"LI",{});var Mt=o(rs);ht=i(Mt,"OS: Ubuntu 18.04.6 LTS."),Mt.forEach(t),ct=m(U),ps=n(U,"LI",{});var zt=o(ps);mt=i(zt,"GPU: Tesla T4"),zt.forEach(t),ft=m(U),is=n(U,"LI",{});var Ht=o(is);ut=i(Ht,"Driver Version: 460.32.03"),Ht.forEach(t),dt=m(U),hs=n(U,"LI",{});var Bt=o(hs);gt=i(Bt,"CUDA Version: 11.2"),Bt.forEach(t),U.forEach(t),this.h()},h(){h(g,"name","hf:doc:metadata"),h(g,"content",JSON.stringify(se)),h(j,"id","speed-comparison"),h(j,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(j,"href","#speed-comparison"),h(_,"class","relative group"),h(I,"alt","Open In Colab"),h(I,"class","!m-0"),Qt(I.src,yt="https://colab.research.google.com/assets/colab-badge.svg")||h(I,"src",yt),h(b,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/safetensors_doc/en/speed.ipynb"),h(b,"target","_blank"),h(b,"class","absolute z-10 right-0 top-0"),h(D,"href","https://huggingface.co/gpt2"),h(D,"rel","nofollow"),h(B,"href","#gpu-benchmark"),h(v,"id","cpu-benchmark"),h(v,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(v,"href","#cpu-benchmark"),h(y,"class","relative group"),h(M,"href","https://gist.github.com/Narsil/3edeec2669a5e94e4707aa0f901d2282"),h(M,"rel","nofollow"),h(P,"id","gpu-benchmark"),h(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(P,"href","#gpu-benchmark"),h(w,"class","relative group")},m(s,a){e(document.head,g),r(s,ms,a),r(s,_,a),e(_,j),e(j,K),L(A,K,null),e(_,Ds),e(_,Q),e(Q,Os),r(s,fs,a),r(s,b,a),e(b,I),r(s,us,a),r(s,f,a),e(f,W),e(W,xs),e(f,Ns),e(f,Y),e(Y,Xs),e(f,Rs),e(f,D),e(D,Ms),e(f,zs),e(f,B),e(B,Hs),e(f,Bs),e(f,Z),e(Z,Fs),e(f,Vs),r(s,ds,a),r(s,F,a),e(F,Js),r(s,gs,a),L(O,s,a),r(s,_s,a),r(s,V,a),e(V,Ks),r(s,bs,a),L(x,s,a),r(s,ys,a),r(s,J,a),e(J,Qs),r(s,ws,a),L(N,s,a),r(s,js,a),r(s,y,a),e(y,v),e(v,ss),L(X,ss,null),e(y,Ws),e(y,ts),e(ts,Ys),r(s,vs,a),L(R,s,a),r(s,$s,a),r(s,$,a),e($,Zs),e($,M),e(M,st),e($,tt),r(s,ks,a),r(s,k,a),e(k,es),e(es,et),e(k,at),e(k,as),e(as,lt),r(s,Ps,a),r(s,w,a),e(w,P),e(P,ls),L(z,ls,null),e(w,nt),e(w,ns),e(ns,ot),r(s,Es,a),L(H,s,a),r(s,Us,a),r(s,E,a),e(E,rt),e(E,os),e(os,pt),e(E,it),r(s,qs,a),r(s,u,a),e(u,rs),e(rs,ht),e(u,ct),e(u,ps),e(ps,mt),e(u,ft),e(u,is),e(is,ut),e(u,dt),e(u,hs),e(hs,gt),Ss=!0},p:Wt,i(s){Ss||(C(A.$$.fragment,s),C(O.$$.fragment,s),C(x.$$.fragment,s),C(N.$$.fragment,s),C(X.$$.fragment,s),C(R.$$.fragment,s),C(z.$$.fragment,s),C(H.$$.fragment,s),Ss=!0)},o(s){T(A.$$.fragment,s),T(O.$$.fragment,s),T(x.$$.fragment,s),T(N.$$.fragment,s),T(X.$$.fragment,s),T(R.$$.fragment,s),T(z.$$.fragment,s),T(H.$$.fragment,s),Ss=!1},d(s){t(g),s&&t(ms),s&&t(_),G(A),s&&t(fs),s&&t(b),s&&t(us),s&&t(f),s&&t(ds),s&&t(F),s&&t(gs),G(O,s),s&&t(_s),s&&t(V),s&&t(bs),G(x,s),s&&t(ys),s&&t(J),s&&t(ws),G(N,s),s&&t(js),s&&t(y),G(X),s&&t(vs),G(R,s),s&&t($s),s&&t($),s&&t(ks),s&&t(k),s&&t(Ps),s&&t(w),G(z),s&&t(Es),G(H,s),s&&t(Us),s&&t(E),s&&t(qs),s&&t(u)}}}const se={local:"speed-comparison",sections:[{local:"cpu-benchmark",title:"CPU benchmark"},{local:"gpu-benchmark",title:"GPU benchmark"}],title:"Speed Comparison"};function te(bt){return Yt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class le extends Ft{constructor(g){super();Vt(this,g,te,Zt,Jt,{})}}export{le as default,se as metadata};
